/*-------------------------------------------------------------------*
 *                         UTIL_fx.C									 *
 *-------------------------------------------------------------------*/
 
#include "typedef.h"
#include "basic_op.h"
#include "count.h"


#include "amr_plus_fx.h"
#include "stdio.h"

/*---------------------------------------------------------------*
 * Cos_windows                                                   
 *                                                               
 * To compute cosine window in tcx overlap
 * Based on a 128 cosine table length
 *---------------------------------------------------------------*/
#define DELAY_MAX (D_BPF +L_SUBFR+ L_BSP + 2*D_NC + L_FDEL + 32*D_STEREO_TCX/5)

void Cos_window(Word16 *fh, Word16 n1, Word16 n2, Word16 inc2)
{ 
  Word16 i;
  Word16 inc, offset,offset2;
  Word32 Ltmp;
  const Word16 *pt_cosup, *pt_cosdwn;

  /* compute offset from beginning of table andjump size */
  offset2 = 1;  move16();
  test();test();test();test();
  if(sub(n1, L_OVLP) == 0)
  {
     inc = 1;  move16();
     offset2 = 0;  move16();
  }
  else if(sub(n1, L_OVLP/2) == 0)
  {
     inc = 2;  move16();
  }
  else if(sub(n1, L_OVLP/4) == 0)
  {
     inc = 4;  move16();
  }
  else if(sub(n1, L_OVLP/8) == 0)
  {
     inc = 8;  move16();
  }
  else
  {
     inc = 16;  move16();
  }
  offset = sub(shr(inc,1),1);
  test();
  if(offset < 0)
  {
    offset = 0;   move16();
  }
  
  /* Calculate first cosine part */
  pt_cosup = Cos_wind + offset;
  for(i = 0;i <n1; i++)
  {
    Ltmp = L_mult(*pt_cosup, 16384);
    Ltmp = L_mac(Ltmp, *(pt_cosup+offset2), 16384);
    *fh = round(Ltmp);        move16();
    fh++; pt_cosup += inc;
  }

  /* compute offset from beginning of table and jump size for second part*/
  offset = sub(shr(inc2,1),1);
  test();
  if(offset < 0)
  {
    offset = 0;   move16();
  }
  test();
  if(sub(inc2,1) == 0)
  {
    offset2 = 0;      move16();
  }
  else
  {
    offset2 = 1;      move16();
  }

  pt_cosdwn = Cos_wind + L_OVLP - 1 - offset;
  /* Calculate second cosine part */
  for(i = 0;i <n2; i++)
  {
    Ltmp = L_mult(*pt_cosdwn, 16384);
    Ltmp = L_mac(Ltmp, *(pt_cosdwn-offset2), 16384);
    *fh = round(Ltmp);        move16();
    fh++; pt_cosdwn -= inc2;
  }
  return;
}
void Ifft_reorder(Word16 xri[], Word16 lg)
{
  Word16 i, tmp1, lg2;
  Word16 im[576], *pt_re, *pt_im, *pt_ims;

  tmp1 = xri[1]; move16();
  pt_re = &xri[2];
  pt_im = &xri[3];
  pt_ims = im;

  lg2 = shr(lg,1);
  for(i = 1; i<lg2; i++)
  {
    xri[i] = *pt_re; 
    *pt_ims++ = *pt_im;    move16();
    pt_im += 2;
    pt_re += 2;
  }
  xri[lg2] = tmp1;  move16(); 
  pt_im = &im[0];   move16();
  lg2 = add(lg2,1);
  for(i = lg2; i<lg; i++)
  {
    xri[i] = *pt_im++;   move16();
  }
}

void Delay(
  Word16 signal[],    /* (i/o): Signal to delay */
  Word16 lg,          /* (i)  : Length          */
  Word16 delay,       /* (i)  : Delay to apply  */
  Word16 mem[]        /* (i/o): Delay memory    */
)
{ 
  Word16 i;
  Word16 buf[DELAY_MAX];

  for (i=0; i<delay; i++) 
  {
    buf[i] = mem[i];                move16();
  }
  for (i=0; i<delay; i++) 
  {
    mem[i] = signal[lg-delay+i];    move16();
  }
  lg = sub(lg,1);
  for (i=lg; i>=delay; i--) 
  {
    signal[i] = signal[i-delay];    move16();
  }
  for (i=0; i<delay; i++) 
  {
    signal[i] = buf[i];             move16();
  }
  return;
}
